//------------------file: ./P1/I1.java--------------------------------------------
package P1;
/**
  This interface implements only one method, namely m1() and
  is another interface I3 extends I1.
  <P>
  Comments about Javadoc's first sentence: <P>
  <UL>
  <LI>Don't put html tags in the first sentence.
  <LI>The first sentence ends at the first period that is followed by a blank,
  tab, or line terminator, or at the first standalone tag.
  this first sentence to the member summary at the top of the HTML page.
  <LI>The first sentence of each doc comment should be a summary sentence,
  containing a concise but complete description of the  declared  entity.
  <LI>javadoc copies this  first sentence to the member summary at the top of the HTML page.
  </UL>
  <P>
  Comments about Interfaces:<P>
  <UL>
  <LI>An interface is declared using the keyword <B>interface</B>.
  <LI>Interfaces should deal with the services provided by an object, not its data. 
  <LI>Sun Definition: An interface is a named collection of method definitions
  (without implementations).
  <LI>Interfaces provide for multiple inheritance as well as
  information hiding and code re-use.
  <LI>An interface is a totally abstract class: An interface
  <U>cannot</U> implement any methods whereas an abstract class can
  implement default methods.
  <LI>All interface methods are implicitly abstract and public,
  regardless of what you write in the interface definition.
  <LI>Since, the interface itself is already abstract.
  It might be possible to write: <i>public abstract interface I1{}.</i>
  But there's no point, since it's redundant.
  <LI>An interface is <U>not</u> part of the any class hierarchy.
  <LI>A class can implement many interfaces
  but can only have  <u>one</u> superclass (i.e. extends supperclass).
  <LI>Any additional inheritance (i.e. multiple inheritance)
  is achieved through implementation of interfaces.
  <LI>Field variables are cannot be used within interfaces.
  <LI>Interfaces cannot directly model classes
  because they do not allow <i>method</i> implementations (i.e. behaviors)
  or <i>field variables</i>. 
  <LI>Interface field variables are emulated by using wrapper
  methods for getting and setting the variables.
  <LI>Abstract an concrete classes can declare field variables.
  <LI><I>Unrelated classes</I> can implement the same interface:
  For example, <i>public class F1 implements I1 { }</i>
  and <i>public class G1 implements I1, I5 { }</i>
  <LI>An interface may extend zero or more interfaces if it likes,
  but it cannot extend a class, because then it would inherit functionality,
  and interfaces cannot have functionality (i.e. cannot implement any methods).
  They can only talk about it.
  <LI>It is possible to place widely used constants in an interface. 
  If a class implements such an interface, then the class can refer
  to those constants without a qualifying class name. 
  <LI>Interface constants which are implicitly
  "public", "static" and "final".
  <LI>Interface constants were a popular technique in the early days
  of Java, but now many consider it  ugly use of interfaces,
  since interfaces should deal with the services provided by an object, not its data. 
  </UL>

  @author Francis G. Wolff
  @version 1.0 %I% %U%
  @see     I3
*/
public interface I1 {
  /**
  This method m1 returns a string.
  @return String
  */
  public String m1();
}

